<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-card-section>
            <div
              class="text-body2 q-mb-sm"
            >
              <translate>Do you plan to whiten your greenhouse rooftop ?</translate>
            </div>
            <q-btn-toggle
              v-model="storeWhitening"
              :options="[{value: true, label: $gettext('Yes')}, {value: false, label: $gettext('No')}]"
              toggle-color="primary"
            />
          </q-card-section>

          <q-card-section v-if="storeWhitening">
            <div
              class="text-body2 q-mb-sm"
            >
              <translate>Please indicate the whitening application periods</translate>:
            </div>
            <q-list
              separator
            >
              <q-item
                class="q-px-none"
                v-for="(whiteningPeriod, index) in storeWhiteningPeriods"
                :key="'whitening-period-'+index"
              >
                <div class="full-width row no-wrap flex-center">
                  <div class="col">
                    <q-item-label class="text-bold">
                      <span style="display: inline-block;">{{ displayDate(whiteningPeriod.from) }}</span>
                      -
                      <span style="display: inline-block;">{{ displayDate(whiteningPeriod.to) }}</span>
                    </q-item-label>
                    <q-item-label>
                      <translate>Transmissivity</translate>: {{ whiteningPeriod.transmissivityValue }}
                    </q-item-label>
                  </div>
                  <div class="col-auto q-ml-sm">
                    <q-btn
                      color="primary"
                      size="sm"
                      outline
                      icon="las la-pen"
                      @click="editWhiteningPeriod(index)"
                    />
                    <q-btn
                      class="q-ml-sm"
                      color="negative"
                      size="sm"
                      outline
                      icon="las la-trash"
                      @click="deleteWhiteningPeriod(index)"
                    />
                  </div>
                </div>
              </q-item>
              <q-item v-if="storeWhiteningPeriods == null || storeWhiteningPeriods.length === 0">
                <q-item-label caption>
                  <translate>Click on the "add" button to add a new whitening application period</translate>
                </q-item-label>
              </q-item>
            </q-list>
            <q-separator v-show="storeWhiteningPeriods != null && storeWhiteningPeriods.length" />
            <q-card-actions
              align="right"
              class="q-px-none"
            >
              <q-btn
                color="primary"
                :label="$gettext('Add')"
                @click="addWhiteningPeriod"
              />
            </q-card-actions>
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
      <q-dialog
        v-if="storeWhitening"
        v-model="showAddOrEditWhiteningPeriodDialog"
        :full-width="!isDesktopPlatform"
      >
        <q-card style="min-width: min(500px, 80vw)">
          <q-card-section>
            <div
              class="text-body2 q-mb-sm"
            >
              <translate>Indicate your application dates</translate>:
            </div>
            <translate class="text-grey">
              Starting date
            </translate>
            <DateSelectorInput
              v-model="whiteningPeriodData.from"
              :date-options="whiteningStartDateOptions"
              :date-events="whiteningDateEvents"
            />
            <translate class="text-grey ">
              Ending date
            </translate>
            <DateSelectorInput
              v-model="whiteningPeriodData.to"
              :date-options="whiteningEndDateOptions"
              :date-events="whiteningDateEvents"
            />
            <div
              class="text-body2 q-mb-sm"
            >
              <translate>Select the transmissivity</translate>:
            </div>
            <div v-if="!hasLoadedTransmissivityOptions">
              <q-spinner-dots
                size="24px"
                color="primary"
              />
            </div>
            <q-list v-else>
              <!-- defined options -->
              <q-item
                v-for="transmissivityOption in transmissivityOptions"
                :key="'transmissivity-' + transmissivityOption.label"
                class="q-pl-none"
                dense
              >
                <q-radio
                  v-model="whiteningPeriodData.transmissivityType"
                  :val="transmissivityOption.label"
                  :label="`${transmissivityOption.label} - ${transmissivityOption.transmissivity}`"
                  @update:model-value="() => whiteningPeriodData.transmissivityValue = transmissivityOption.transmissivity"
                />
              </q-item>
              <!-- custom -->
              <q-item
                class="q-pl-none"
                dense
              >
                <q-radio
                  v-model="whiteningPeriodData.transmissivityType"
                  val="custom"
                  @update:model-value="() => whiteningPeriodData.transmissivityValue = null"
                  :label="whiteningPeriodData.transmissivityType !== 'custom' ? $gettext('Custom') : null"
                />
                <q-input
                  v-if="whiteningPeriodData.transmissivityType === 'custom'"
                  filled
                  type="number"
                  :label="$gettext('Custom')"
                  :model-value="whiteningPeriodData.transmissivityValue"
                  @update:model-value="value => whiteningPeriodData.transmissivityValue = value < transmissivityMin ? transmissivityMin : value > transmissivityMax ? transmissivityMax : Math.abs(value)"
                  :rules="customTransmissivityRules"
                  :min="transmissivityMin"
                  :max="transmissivityMax"
                  class="full-width"
                  step="0.1"
                  :loading="!hasLoadedInputsControl"
                />
              </q-item>
            </q-list>
          </q-card-section>
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canSaveWhiteningPeriod"
                @click="onSaveWhiteningPeriod"
              >
                <template v-if="editionIndex == null">
                  <translate>Add</translate>
                </template>
                <template v-else>
                  <translate>Save</translate>
                </template>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="showAddOrEditWhiteningPeriodDialog = false"
              >
                <translate>Cancel</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </q-dialog>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { date } from 'quasar'

import { PlatformMixin } from 'src/mixins/PlatformMixin'
import { DateMixin } from 'src/mixins/DateMixin'
import { ConfirmMixin } from 'src/mixins/DialogMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import VegsystMixin from 'src/pages/fieldbook/fertilization/algorithms/vegsyst/mixins/VegsystMixin'
import DateSelectorInput from 'src/components/form/DateSelectorInput'
import queryVegsystTransmissivity from 'src/pages/fieldbook/fertilization/algorithms/vegsyst/graphql/queryVegsystTransmissivity'

const { formatDate } = date

const initWhiteningPeriodData = {
  from: null,
  to: null,
  transmissivityValue: null,
  transmissivityType: null
}

export default {
  name: 'VegsystWhiteningPage',
  components: {
    GenericLayout,
    Header,
    Footer,
    DateSelectorInput
  },
  mixins: [PlatformMixin, DateMixin, ConfirmMixin, AlgorithmsMixins, VegsystMixin],
  data () {
    return {
      showAddOrEditWhiteningPeriodDialog: false,
      editionIndex: null,
      whiteningPeriodData: { ...initWhiteningPeriodData },
      hasLoadedTransmissivityOptions: false
    }
  },
  computed: {
    canSaveWhiteningPeriod () {
      return this.whiteningPeriodData.from != null &&
        this.whiteningPeriodData.to != null &&
        this.whiteningPeriodData.transmissivityValue != null
    },
    canContinue () {
      return this.storeWhitening != null && (!this.storeWhitening || this.storeWhiteningPeriods?.length)
    },
    customTransmissivityRules () {
      return [
        val => val != null || `* ${this.$gettext('This field is required')}`,
        val => (val >= this.transmissivityMin && val <= this.transmissivityMax) ||
          `${this.$gettextInterpolate(this.$gettext('transmissivity must be between %{min} and %{max}'), { min: this.transmissivityMin, max: this.transmissivityMax })}`
      ]
    },
    pageTitle () {
      return this.$pgettext('Whitening operation for greenhouse rooftop', 'Whitening')
    },
    pageSubTitle () {
      return 'VegSyst'
    },
    storePlantingMethodFrom () {
      return this.$store.state.fertilizationPlan.parameters.plantingMethodFrom
    },
    storePlantingMethodTo () {
      return this.$store.state.fertilizationPlan.parameters.plantingMethodTo
    },
    storeWhitening: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.whitening
      },
      set (v) {
        this.updateParameter('whitening', v)
      }
    },
    storeWhiteningPeriods: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.whiteningPeriods
      },
      set (v) {
        this.updateParameter('whiteningPeriods', v)
      }
    },
    transmissivityMin () {
      if (this.hasLoadedInputsControl) {
        return this.vegsystInputsControl?.whitening_transmissivity?.min_value ?? undefined
      } else {
        return undefined
      }
    },
    transmissivityMax () {
      if (this.hasLoadedInputsControl) {
        return this.vegsystInputsControl?.whitening_transmissivity?.max_value ?? undefined
      } else {
        return undefined
      }
    }
  },
  apollo: {
    transmissivityOptions: {
      query: queryVegsystTransmissivity,
      notifyOnNetworkStatusChange: true,
      update (data) {
        this.hasLoadedTransmissivityOptions = true
        return data.vegsyst__transmissivity
      }
    }
  },
  methods: {
    addWhiteningPeriod () {
      this.resetWhiteningPeriodData()
      this.editionIndex = null
      this.showAddOrEditWhiteningPeriodDialog = true
    },
    editWhiteningPeriod (index) {
      this.whiteningPeriodData = { ...this.storeWhiteningPeriods[index] }
      this.editionIndex = index
      this.showAddOrEditWhiteningPeriodDialog = true
    },
    async deleteWhiteningPeriod (index) {
      const period = this.storeWhiteningPeriods[index]
      const c = await this.confirm({
        title: this.$gettextInterpolate(
          this.$gettext('Delete the whitening operation from %{startingDate} to %{endingDate} ?'),
          {
            startingDate: this.displayDate(period.from),
            endingDate: this.displayDate(period.to)
          }),
        persistent: false,
        ok: {
          label: this.$gettext('delete'),
          color: 'primary'
        },
        cancel: {
          label: this.$gettext('cancel'),
          color: 'primary',
          flat: true
        }
      })
      if (c) {
        const periods = [...this.storeWhiteningPeriods]
        // delete element at giving index
        periods.splice(index, 1)
        this.storeWhiteningPeriods = periods
      }
    },
    onClickNext () {
      if (this.$store.state.fertilizationPlan.parameters.croppingMedia?.id === 'Suelo') {
        this.$router.push({
          name: 'vegsystSoilPage'
        })
      } else {
        this.$router.push({
          name: 'vegsystIrrigationLayoutPage'
        })
      }
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'vegsystCropProfilePage'
      })
    },
    // onInputControlQueryUpdate (inputControls) {
    //   // set default values if necessary
    // },
    onSaveWhiteningPeriod () {
      const periods = this.storeWhiteningPeriods != null ? [...this.storeWhiteningPeriods] : []
      if (this.editionIndex != null) {
        const index = this.editionIndex
        periods.splice(index, 1, { ...this.whiteningPeriodData })
      } else {
        periods.push({ ...this.whiteningPeriodData })
      }
      this.storeWhiteningPeriods = periods
      this.showAddOrEditWhiteningPeriodDialog = false
    },
    resetWhiteningPeriodData () {
      this.whiteningPeriodData = { ...initWhiteningPeriodData }
    },
    whiteningDateEvents (date) {
      if (this.storeWhiteningPeriods?.length) {
        for (let i = 0; i < this.storeWhiteningPeriods.length; i++) {
          if (
            date >= formatDate(this.storeWhiteningPeriods[i].from, 'YYYY/MM/DD') &&
              date <= formatDate(this.storeWhiteningPeriods[i].to, 'YYYY/MM/DD')
          ) return true
        }
      }
      return false
    },
    whiteningDateOptions (date, isStartDateElseEndDate) {
      if (
        date < formatDate(this.storePlantingMethodFrom, 'YYYY/MM/DD') ||
        date > formatDate(this.storePlantingMethodTo, 'YYYY/MM/DD')
      ) {
        return false
      } else {
        if (this.whiteningPeriodData[isStartDateElseEndDate ? 'to' : 'from'] != null) {
          // check that the date is inferior to the end date or the end date is superior to the start date
          if (
            isStartDateElseEndDate
              ? date >= formatDate(this.whiteningPeriodData.to, 'YYYY/MM/DD')
              : date <= formatDate(this.whiteningPeriodData.from, 'YYYY/MM/DD')
          ) return false
        }
        if (this.storeWhiteningPeriods?.length) {
          for (let i = 0; i < this.storeWhiteningPeriods.length; i++) {
            if (
              this.editionIndex !== i &&
              date >= formatDate(this.storeWhiteningPeriods[i].from, 'YYYY/MM/DD') &&
              date <= formatDate(this.storeWhiteningPeriods[i].to, 'YYYY/MM/DD')
            ) return false
          }
        }
        return true
      }
    },
    whiteningStartDateOptions (date) {
      return this.whiteningDateOptions(date, true)
    },
    whiteningEndDateOptions (date) {
      return this.whiteningDateOptions(date, false)
    }
  }
}
</script>
